/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.records.TCoreRepeatgrpRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreRepeatgrp extends TableImpl<TCoreRepeatgrpRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_repeatgrp</code>
     */
    public static final TCoreRepeatgrp T_CORE_REPEATGRP = new TCoreRepeatgrp();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreRepeatgrpRecord> getRecordType() {
        return TCoreRepeatgrpRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_repeatgrp.lastchange</code>.
     */
    public final TableField<TCoreRepeatgrpRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_repeatgrp.pk</code>.
     */
    public final TableField<TCoreRepeatgrpRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_repeatgrp.fk_key_element</code>.
     * Foreign key to t_core_element_hierarchy
     */
    public final TableField<TCoreRepeatgrpRecord, Integer> FK_KEY_ELEMENT = createField(DSL.name("fk_key_element"), SQLDataType.INTEGER.nullable(false), this, "Foreign key to t_core_element_hierarchy");

    /**
     * The column <code>common_dd.t_core_repeatgrp.max_iteration</code>.
     */
    public final TableField<TCoreRepeatgrpRecord, Integer> MAX_ITERATION = createField(DSL.name("max_iteration"), SQLDataType.INTEGER, this, "");

    private TCoreRepeatgrp(Name alias, Table<TCoreRepeatgrpRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreRepeatgrp(Name alias, Table<TCoreRepeatgrpRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_repeatgrp</code> table reference
     */
    public TCoreRepeatgrp(String alias) {
        this(DSL.name(alias), T_CORE_REPEATGRP);
    }

    /**
     * Create an aliased <code>common_dd.t_core_repeatgrp</code> table reference
     */
    public TCoreRepeatgrp(Name alias) {
        this(alias, T_CORE_REPEATGRP);
    }

    /**
     * Create a <code>common_dd.t_core_repeatgrp</code> table reference
     */
    public TCoreRepeatgrp() {
        this(DSL.name("t_core_repeatgrp"), null);
    }

    public <O extends Record> TCoreRepeatgrp(Table<O> path, ForeignKey<O, TCoreRepeatgrpRecord> childPath, InverseForeignKey<O, TCoreRepeatgrpRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_REPEATGRP);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreRepeatgrpPath extends TCoreRepeatgrp implements Path<TCoreRepeatgrpRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreRepeatgrpPath(Table<O> path, ForeignKey<O, TCoreRepeatgrpRecord> childPath, InverseForeignKey<O, TCoreRepeatgrpRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreRepeatgrpPath(Name alias, Table<TCoreRepeatgrpRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreRepeatgrpPath as(String alias) {
            return new TCoreRepeatgrpPath(DSL.name(alias), this);
        }

        @Override
        public TCoreRepeatgrpPath as(Name alias) {
            return new TCoreRepeatgrpPath(alias, this);
        }

        @Override
        public TCoreRepeatgrpPath as(Table<?> alias) {
            return new TCoreRepeatgrpPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreRepeatgrpRecord, Integer> getIdentity() {
        return (Identity<TCoreRepeatgrpRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreRepeatgrpRecord> getPrimaryKey() {
        return Keys.PK_CORE_REPEATGRP;
    }

    @Override
    public List<ForeignKey<TCoreRepeatgrpRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_REPEATGRP__FK_CORE_REPEATGRP_HIERARCHY);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_REPEATGRP__FK_CORE_REPEATGRP_HIERARCHY, null);

        return _tCoreElementHierarchy;
    }

    @Override
    public TCoreRepeatgrp as(String alias) {
        return new TCoreRepeatgrp(DSL.name(alias), this);
    }

    @Override
    public TCoreRepeatgrp as(Name alias) {
        return new TCoreRepeatgrp(alias, this);
    }

    @Override
    public TCoreRepeatgrp as(Table<?> alias) {
        return new TCoreRepeatgrp(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreRepeatgrp rename(String name) {
        return new TCoreRepeatgrp(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreRepeatgrp rename(Name name) {
        return new TCoreRepeatgrp(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreRepeatgrp rename(Table<?> name) {
        return new TCoreRepeatgrp(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreRepeatgrp where(Condition condition) {
        return new TCoreRepeatgrp(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreRepeatgrp where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreRepeatgrp where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreRepeatgrp where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreRepeatgrp where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreRepeatgrp where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreRepeatgrp where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreRepeatgrp where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreRepeatgrp whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreRepeatgrp whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
